public class Converter {
    static void packLong(byte[] arr, int offs, long x) { 
        packInt(arr, offs, (int)(x >> 32));
        packInt(arr, offs+4, (int)x);
    }
        
    static void packInt(byte[] arr, int offs, int x) { 
        arr[offs] = (byte)(x >> 24);
        arr[offs+1] = (byte)(x >> 16);
        arr[offs+2] = (byte)(x >> 8);
        arr[offs+3] = (byte)x;
    }

    static int unpackInt(byte[] arr, int offs) { 
        return (arr[offs] << 24) | ((arr[offs+1] & 0xFF) << 16) | ((arr[offs+2] & 0xFF) << 8) | (arr[offs+3] & 0xFF);
    }

    static long unpackLong(byte[] arr, int offs) { 
        return ((long)unpackInt(arr, offs) << 32) | (unpackInt(arr, offs+4) & 0xFFFFFFFFL);
    }

    static void packString(byte[] arr, int offs, String str) { 
        for (int i = 0, n = str.length(); i < n; i++) { 
            char ch = str.charAt(i);
            arr[offs++] = (byte)(ch >> 8);
            arr[offs++] = (byte)ch;
        }
    }
    
    static String unpackString(byte[] arr, int offs, int len) { 
        len >>= 1;
        char[] chars = new char[len];
        for (int i = 0; i < len; i++) { 
            chars[i] = (char)((arr[offs + i*2] << 8) | (arr[offs + i*2 + 1] & 0xFF));
        }  
        return new String(chars);              
    }
}

