import javax.microedition.media.control.ToneControl;

public class Settings {
    static final int SOUND = 1;
    static final int VIBRA = 2;    
    static final int BACKLIGHT = 4;    
    static final int SMS = 8;

    static final int DEFAULT_NOTE = ToneControl.C4;
    static final int DEFAULT_DURATION = 30;
    static final int DEFAULT_FREQUENCY = 2;
    static final int DEFAULT_VOLUME = 100;
    static final int DEFAULT_NOTIFICATION = SOUND|VIBRA|BACKLIGHT;

    int notification;
    int duration;
    int frequency;
    int volume;
    int note;
    String sms;

    byte[] pack() { 
        byte[] smsBytes = sms.getBytes();
        byte[] record = new byte[smsBytes.length + 6];
        record[0] = (byte)note;
        record[1] = (byte)(duration >> 8);
        record[2] = (byte)duration;
        record[3] = (byte)volume;
        record[4] = (byte)notification;
        record[5] = (byte)frequency;
        System.arraycopy(smsBytes, 0, record, 6, smsBytes.length);
        return record;
    }
    
    Settings() { 
        note = DEFAULT_NOTE;
        duration = DEFAULT_DURATION;
        frequency = DEFAULT_FREQUENCY;
        volume = DEFAULT_VOLUME;
        notification = DEFAULT_NOTIFICATION;     
        sms = "";
    }

    Settings(byte[] record) { 
        note = record[0] & 0xFF;
        duration = ((record[1] & 0xFF) << 8) | (record[2] & 0xFF);
        volume = record[3] & 0xFF;
        notification = record[4];
        frequency = record[5];
        sms = new String(record, 6, record.length-6);
    }
}

